# class Prism::ImplicitNode

Represents a node that is implicitly being added to the tree but doesn’t correspond directly to a node in the source.

    { foo: }
      ^^^^

    { Foo: }
      ^^^^

    foo in { bar: }
             ^^^^

### Attributes

value [R]

attr_reader value: `LocalVariableReadNode` | `CallNode` | `ConstantReadNode` | `LocalVariableTargetNode`

### Public Class Methods

new (source, node_id, location, flags, value)
Source

    # File lib/prism/node.rb, line 8737
    def initialize(source, node_id, location, flags, value)
      @source = source
      @node_id = node_id
      @location = location
      @flags = flags
      @value = value
    end

Initialize a new `ImplicitNode` node.

type ()
Source

    # File lib/prism/node.rb, line 8792
    def self.type
      :implicit_node
    end

Return a symbol representation of this node type. See ‘Node::type`.

### Public Instance Methods

=== (other)
Source

    # File lib/prism/node.rb, line 8798
    def ===(other)
      other.is_a?(ImplicitNode) &&
        (value === other.value)
    end

Implements case-equality for the node. This is effectively == but without comparing the value of locations. Locations are checked only for presence.

accept (visitor)
Source

    # File lib/prism/node.rb, line 8746
    def accept(visitor)
      visitor.visit_implicit_node(self)
    end

def accept: (`Visitor` visitor) -> void

child_nodes ()
Source

    # File lib/prism/node.rb, line 8751
    def child_nodes
      [value]
    end

def `child_nodes`: () -> Array[nil | Node]

Also aliased as: deconstruct
comment_targets ()
Source

    # File lib/prism/node.rb, line 8761
    def comment_targets
      [value] #: Array[Prism::node | Location]
    end

def `comment_targets`: () -> Array[Node | Location]

compact_child_nodes ()
Source

    # File lib/prism/node.rb, line 8756
    def compact_child_nodes
      [value]
    end

def `compact_child_nodes`: () -> Array

copy (node_id: self.node_id, location: self.location, flags: self.flags, value: self.value)
Source

    # File lib/prism/node.rb, line 8766
    def copy(node_id: self.node_id, location: self.location, flags: self.flags, value: self.value)
      ImplicitNode.new(source, node_id, location, flags, value)
    end

def copy: (?node_id: `Integer`, ?location: `Location`, ?flags: `Integer`, ?value: `LocalVariableReadNode` | `CallNode` | `ConstantReadNode` | `LocalVariableTargetNode`) -> `ImplicitNode`

deconstruct ()

def deconstruct: () -> Array[nil | Node]

Alias for: child_nodes
deconstruct_keys (keys)
Source

    # File lib/prism/node.rb, line 8774
    def deconstruct_keys(keys)
      { node_id: node_id, location: location, value: value }
    end

def `deconstruct_keys`: (Array keys) -> { node_id: `Integer`, location: `Location`, value: `LocalVariableReadNode` | `CallNode` | `ConstantReadNode` | `LocalVariableTargetNode` }

inspect ()
Source

    # File lib/prism/node.rb, line 8782
    def inspect
      InspectVisitor.compose(self)
    end

def inspect -> `String`

type ()
Source

    # File lib/prism/node.rb, line 8787
    def type
      :implicit_node
    end

Return a symbol representation of this node type. See ‘Node#type`.